## NAME

tcprewrite - Rewrite the packets in a pcap file.

## SYNOPSIS

tcprewrite [-flag [value]]... [--opt-name [[=| ]value]]...

All arguments must be options.

## DESCRIPTION

This manual page documents, briefly, the tcprewrite command. Tcprewrite is a tool to rewrite packets stored in pcap(3) file format, such as crated by tools such as tcpdump(1) and ethereal(1). Once a pcap file has had it's packets rewritten, they can be replayed back out on the network using tcpreplay(1).

tcprewrite currently supports the following DLT types: * DLT_C_HDLC * DLT_EN10MB * DLT_LINUX_SSL * DLT_RAW

The packet editing features of tcprewrite which distinguish between "client" and "server" traffic requires a tcpprep(1) cache file.

## OPTIONS

-d number, --dbug=number
  Enable debugging output. This option may appear up to 1 times. The default number for this option is:

0

If configured with --enable-debug, then you can specify a verbosity level for debugging output. Higher numbers increase verbosity.

-D string, --dmac=string
  Rewrite destination MAC addresses. This option may appear up to 1 times.

Takes a pair of comma deliminated ethernet MAC addresses which will replace the destination MAC address of outbound packets. The first MAC address will be used for the server traffic and the optional second MAC address will be used for the client traffic.

Example:

        --dmac 00:12:13:14:15:16,00:22:33:44:55:66

-S string, --smac=string
  Rewrite source MAC addresses. This option may appear up to 1 times.

Takes a pair of comma deliminated ethernet MAC addresses which will replace the source MAC address of outbound packets. The first MAC address will be used for the server traffic and the optional second MAC address will be used for the client traffic.

Example:

        --smac 00:12:13:14:15:16,00:22:33:44:55:66

-P number, --proto=number
  Override L2 protocol type for DLT_RAW. This option may appear up to 1 times.

By default, pcap files encapsulated using DLT_RAW will have their protocol set to ETHERTYPE_IP (0x0800).

-l string, --dlink=string
  Rewrite Data-Link layer with specified data. This option may appear up to 2 times.

Provide a series of comma deliminated hex values which will be used to rewrite or create the Layer 2 header of the packets. The first instance of this argument will rewrite both server and client traffic, but if this argument is specified a second time, it will be used for the client traffic.

Example:

        --dlink 01,02,03,04,05,06,00,11,22,33,44,55,66,08,00

-r string, --portmap=string
  Rewrite TCP/UDP ports. This option may appear up to 1 times.

Specify a list of comma delimited port mappingings consisting of colon delimited port number pairs. Each colon delimited port pair consists of the port to match followed by the port number to rewrite.

Example:

        --portmap 80:8000,8080:80

-s number, --seed=number
  Randomize src/dst IP addresses w/ given seed. This option may appear up to 1 times.

Causes the source and destination IP addresses to be pseudo randomized but still maintain client/server relationships. Since the randomization is deterministic based on the seed, you can reuse the same seed value to recreate the traffic.

-N string, --pnat=string
  Rewrite IP addresses using pseudo-NAT. This option may appear up to 2 times.

Takes a comma delimited series of colon delimited CIDR netblock pairs. Each netblock pair is evaluated in order against the IP addresses. If the IP address in the packet matches the first netblock, it is rewriten using the second netblock as a mask against the high order bits.

Example:

        --pnat 192.168.0.0/16:10.77.0.0/16,172.16.0.0/12:10.1.0.0/24

-e string, --endpoints=string
  Rewrite IP addresses to be between two endpoints. This option may appear up to 1 times.

Takes a pair of colon delimited IP addresses which will be used to rewrite all traffic to appear to be between the two IP's.

Example:

        --endpoints 172.16.0.1:172.16.0.2

-C, --fixcsum
  Force recalculation of IP/TCP/UDP checksums.

Causes each IP packet to have it's checksums recalcualted and fixed. Automatically enabled for packets modified with --seed, --pnat, --endpoints or --fixlen.

-i string, --infile=string
  Input pcap file to be processed. This option may appear up to 1 times.

-o string, --outfile=string
  Output pcap file. This option may appear up to 1 times.

-c string, --cachefile=string
  Split traffic via tcpprep cache file. This option may appear up to 1 times.

Use tcpprep cache file to split traffic based upon client/server relationships.

-m number, --mtu=number
  Override default MTU length (1500 bytes). This option may appear up to 1 times.

Override the default 1500 byte MTU size for determining the maximum padding length.

-E, --efcs
  Remove Ethernet checksums (FCS) from end of frames.

-F string, --fixlen=string
  Pad or truncate packet data to match header length. This option may appear up to 1 times.

Packets may be truncated during capture if the snaplen is smaller then the packet. This option allows you to modify the packet to pad the packet back out to the size stored in the IPv4 header or rewrite the IP header total length to reflect the stored packet length.

pad Truncated packets will be padded out so that the packet length matches the IPv4 total length

trunc Truncated packets will have their IPv4 total length field rewritten to match the actual packet length

-T string, --vlan=string
  Specify 802.1q VLAN tag mode. This option may appear up to 1 times.

Allows you to rewrite ethernet frames to add a 802.1q header to standard 802.3 ethernet headers or remove the 802.1q VLAN tag information.

add Rewrites the existing 802.3 ethernet header as an 802.1q VLAN header

del Rewrites the existing 802.1q VLAN header as an 802.3 ethernet header

-t number, --vlan-tag=number
  Specify the new 802.1q VLAN tag value. This option may appear up to 1 times. This option must appear in combination with the following options: vlan.

-c number, --vlan-cfi=number
  Specify the 802.1q VLAN CFI value. This option may appear up to 1 times. This option must appear in combination with the following options: vlan.

-p number, --vlan-pri=number
  Specify the 802.1q VLAN priority. This option may appear up to 1 times. This option must appear in combination with the following options: vlan.

-v, --verbose
  Print decoded packets via tcpdump to STDOUT. This option may appear up to 1 times.

-A string, --decode=string
  Arguments passed to tcpdump decoder. This option may appear up to 1 times. This option must appear in combination with the following options: verbose.

When enabling verbose mode (-v) you may also specify one or more additional arguments to pass to tcpdump to modify the way packets are decoded. By default, -n and -l are used. Be sure to quote the arguments so that they are not interpreted by tcprewrite. The following arguments are valid: [ -aAeNqRStuvxX ] [ -E spi@ipaddr algo:secret,... ] [ -s snaplen ]

-V, --version
  Print version information.

-h, --less-help
  Display less usage information and exit.

-H, --help
  Display usage information and exit.
-!, --more-help
  Extended usage information passed thru pager.
- [rcfile], --save-opts[=rcfile]
  Save the option state to rcfile. The default is the last configuration file listed in the OPTION PRESETS section, below.
- rcfile, --load-opts=rcfile, --no-load-opts
  Load options from rcfile. The no-load-opts form will disable the loading of earlier RC/INI files. --no-load-opts is handled early, out of order.

## OPTION PRESETS

Any option that is not marked as not presettable may be preset by loading values from configuration ("RC" or ".INI") file(s). The homerc file is "$$/", unless that is a directory. In that case, the file ".tcprewriterc" is searched for within that directory.

## SEE ALSO

tcpdump(1), tcpprep(1), tcpreplay(1)

## AUTHOR

Copyright 2004-2005 Aaron Turner

For support please use the tcpreplay-users@lists.sourceforge.net mailing list.

Released under the Free BSD License.

This manual page was AutoGen-erated from the tcprewrite option definitions.